MODULE Ml4jRule                         (* jl 04.05.2010 *)
  IMPORTS Dp4List, Dp4OP, Dp4Base;
TYPE HVarsT = RECORD ci,cx,ti,tx: INT END;
     VarsT  = FLEX OF RECORD tp, x: INT END;
TYPEND;

Ml4jRule =
	GLOBVAR USE ntL, nt1L, ntxL, ntmL, impL: Dp4List.List;
	  USE HVars: HVarsT;              DCL tt, isSrc: INT;
	  USE VarL: Dp4List.List;
	  USE Vars: VarsT;
	  USE RuleId: SYM; USE ct, srctxt, UsN, UsO, Usc, check: INT;
	VAR oi, ot, op, og, ov, ol, om, os, M, vl: INT;
	
	  Dp4List.New(ntL);  Dp4List.New(nt1L); Dp4List.New(ntxL); vl:= Dp4List.len(VarL);
	  Dp4List.Extend(VarL, 'i');  Dp4List.Extend(VarL, 'c');
	  Dp4List.Extend(VarL, 'N');  Dp4List.Extend(VarL, 'O');
	  {/=vl+1..vl+4/ Vars[i].tp:= 2;Vars[i].x:= 0}  srctxt:= 0; UsO:= 0; UsN:= 0; Usc:= 0;
	
	 id RuleId:= id_0;
	  Dp4List.Unite(ntmL, id_0);
	       [/op/ '(' !! Ml4jFParams  ')' Dp4List.Unite(impL, 'Dp4Param') ]
	 '=' !!             Dp4OP.WrStr('  translating ');Dp4OP.WrStr(id_0);Dp4OP.WrLn();
	       [/og/ 'GLOBVAR' !! Ml4jGlobVars ]
	       [/ov/ 'VAR' !! Ml4jVars ]
	              [/ol/ '$3LOCAL' Ml4jLocals [//';'] ]
	 isSrc:= 1;  Ml4jSrcExp isSrc:= 0;
	  [/os/ '=>' tt:= 4 ct:= 4 Ml4jExpr]
	  {/..M/ '->' !! HVars.ti:= i Ml4jTrgExp[i] }
	 '.'
	->
	 [/ov/ Ml4jVars_2 ]
	'\n//------------------------ ' RuleId ' ------------------------\n'
	'private Dp4.trgts y_p_' RuleId '(Dp4.NonTermT y_NT, Dp4.Prs y_Prs){\n'
	<'I +'>
	'String y_SYM;\nchar y_CHAR;\nDp4.trgts y_0tg= new Dp4.trgts();\nint _c= 0;\n'
	'Dp4.NonTermT y_yNT;\nDp4.tNode y_TXT;\n'
	
	  [/Dp4List.len(nt1L)/ 'Dp4.trgts '
	  {/..Dp4List.len(nt1L)/ (!i#1',') (!i MOD 4=0; '\n         ') 'yy_' Dp4List.Item(nt1L,i)'= null' }
	  ';\n'] [/Dp4List.len(ntxL)/'Dp4.Flex '  {/..Dp4List.len(ntxL)/ (!i#1', ' )
	   (!i MOD 6=0; '\n       ')  'yy_x_' Dp4List.Item(ntxL,i)'= new Dp4.Flex()' }  ';\n' ] ';\n'
	  'int i= 0, c= 1, N= 0, O= 0;\n' [/op/ Ml4jFParams_2]
	  [/ov/ Ml4jVars_  ]
	  [/og/ Ml4jGlobVars_ ] [/srctxt/ 'Dp4.SourcePos yysrctxt1, yysrctxt2;\n']
	  '\ny_yNT= y_translator.curNT; y_translator.curNT= y_NT;\n'
	(* [/check/ {/..Dp4List.len(nt1L)/ 'yy.'  Dp4List.Item(nt1L,i) ':= yB.TrgNotDef;\n' }]*)
	  [/op/ Ml4jFParams_3]
	   [/ol/ Ml4jLocals_ ]
	  [/srctxt/ 'y_CHAR= y_Prs.AC(); yysrctxt1= y_Prs.GetPos();\n']
	       Ml4jSrcExp_ '\n'
	  [/srctxt/ 'y_CHAR= y_Prs.AC(); yysrctxt2= y_Prs.GetPos();\n']
	 [/M+os/ 'if (y_Prs.A) {\n' <'I +'>
	   [/os/ Ml4jExpr_2 'y_0tg.trg0= ' Ml4jExpr_ ';\n' ]
	 <'I 2'>
	   {/..M/ '//------------------------- target no 'i' ------------------------\n'
	      'y_0tg.trg'i'= null;\n' Ml4jTrgExp_[i]  } <'I -'> '\n}\n'  ]
	 (* free globals *)<'I +'>  [/og/ Ml4jGlobVars_4 ] [/ol/ Ml4jLocals_2 ] <'I 2'>
	  'y_translator.curNT= y_yNT;\nreturn y_0tg;\n' <'I 1'> '}\n\n'
	->
	  [/og/ Ml4jGlobVars_3 ]
	->
	  [/op/ Ml4jFParams_4]
	->
	  [/op/ Ml4jFParams_]
.
                                                    
Ml4jSrcExp =
   GLOBVAR USE Usc, UsN, UsO, ext: INT;
   VAR j,  usN, usO, exl: INT;

  usN:= UsN; usO:= UsO;
  ('/' '/'!!| '/' Var:Ml4jVarUse; exl:= ext; Ml4jSrcChk '/'!! | '/' Ml4jExpr Ml4jSrcChk '/'!!| )
   SrcF:Ml4jSrcFact
  {  '|' !!  UsN:= usN; UsO:= usO;
                 Ml4jSrcFact[i]  }
  (//!(N>0)&(c=4); INC(Usc); (//!Usc>1; WARNING(24)|)|)
->
   (!N=0 SrcF_
   |  '// * case begin * /\n'
      ( 'y_Prs.SetB();\n'
      | 'y_Prs.SetB();\n'
      |
      | 'y_Prs.SetB();\n'
      )
      (!c#1 'switch ('(|'1'|Ml4jExpr_|'1')'){' <'I +'> '\ncase 1: ' <'I +'> )
      SrcF_ 
      (!c#1 '\n'
            (|'_c= 1;\nif (y_Prs.A) break; else y_Prs.BckTr();' 
            | ' break;'
            |'c= 1;\nif (y_Prs.A) break; else y_Prs.BckTr();'
            ) <'I -'> )  '\n'
      (!c#1  { 'case ' i+1 ': ' <'I +'> Ml4jSrcFact_[i] '\n'
	             (|'_c= 'i+1';\nif (y_Prs.A) break; else y_Prs.BckTr();' 
	             | ' break;'
	             |'c= 'i+1';\nif (y_Prs.A) break; else y_Prs.BckTr();' 
	             )'\n' <'I -'>} 
       )
      (!c#1 'default: y_Prs.A= false;\n  '
      		(
      		|'_c= 0;'
      		|'y_Prs.LogPos();Dp4.OP.ERROR(14);' 
      		|'c= 0;'
      		)
      )
      ( { 'if (!y_Prs.A){\n' <'I +'>  'y_Prs.BckTr();\n' Ml4jSrcFact_[i] <'I -'> '\n}\n'}
         'if (!y_Prs.A) {\n  y_Prs.BckTr();\n  y_Prs.A= false;\n}\ny_Prs.DelB();'
      | <'I -'> '\n}\nif (y_Prs.A) {\n  '(/exl+1/ Var_'= _c;' | Var_2 '= new Integer(_c);')
                                '\n} else {\n  y_Prs.BckTr(); y_Prs.A= false;\n}\ny_Prs.DelB();'
      | <'I -'> '\n} '
      | <'I -'> '\n}\nif (!y_Prs.A) {\n  y_Prs.BckTr(); y_Prs.A= false;\n}\ny_Prs.DelB();'
      ) '\n// * case end * /'
   )
.

Ml4jSrcFact=                  
	GLOBVAR DCL ifp: INT; USE stat: INT;
	VAR ends:INT; oif:FLEX OF INT;
	
	  ends:= 0     oif[1]:= 0
	
	  { ifp:= 1
	     Ml4jSrcElem[i]  oif[i+1]:= ifp ends:= ends+oif[i] }

->
   { [/1-stat/ (!i>1'\n') [/oif[i]/ 'if (y_Prs.A) {\n'<'I +'>]]
     Ml4jSrcElem_[i] [/stat/ '\n'] }                                   (* // INIT part!*)
   [/1-stat/ [/ends/'\n'] {/..ends/ <'I -'> '} ' (!i MOD 10=0 '\n')} ]
.

Ml4jSrcChk = 
 GLOBVAR USE ct: INT;
  [//!(ct#0)&(ct#2) ; ERROR(3) ].

END Ml4jRule


(* /05.05.03 target layout improved
   /05.03.03 Ml4jWrnPos removed
   /23.03.01 adapted to 1.9
   /17.11.98 target layout improved
   /29.04.97
   /23.09.96 Ml4jWrnPos
   /27.08.96 default targets
   /15.08.96
   /18.03.96 Ml4jSrcChk added
*)
