/** Depot4 (c) J. Lampe 1996-2010
Flx.java

    @author  J. Lampe
    @version  1.9.4
    date: 24.04.2003
    */

package Dp4;

public class Flx extends Flex {
  private Object muster;

  public FlexElem at(int i){
    FlexElem t= super.at(i);
    if (t.val==null) t.val= clone(muster);
    return t;
  }

  public FlexElem at(int i, int j){
    FlexElem t= super.at(i, j);
    if (t.val==null) t.val= clone(muster);
    return t;
  }

	public Flx (Object o) {
		muster= o;
	}

//--------------------------------- clone methods ------------------------
  public static Object clone(Object s){
    if (s instanceof int[]) return clone((int[])s);
    if (s instanceof boolean[]) return clone((boolean[])s);
    if (s instanceof float[]) return clone((float[])s);
    if (s instanceof Object[]) return clone((Object[])s);
    return s;
  }
  public static int[] clone(int[] s){
    int l= s.length;
    int []t= new int[l];
    System.arraycopy(s, 0, t, 0, l);
    return t;
  } 
  public static boolean[] clone(boolean[] s){
    int l= s.length;
    boolean []t= new boolean[l];
    System.arraycopy(s, 0, t, 0, l);
    return t;
  } 
  public static float[] clone(float[] s){
    int l= s.length;
    float[] t= new float[l];
    System.arraycopy(s, 0, t, 0, l);
    return t;
  } 
  public static Object[] clone(Object[] s){
    int l= s.length;
    Object[] t= new Object[l];
    for (int i= 0; i<l;i++) {
      if (s[i] instanceof Object[]) t[i]= clone((Object[])s[i]);
      else {
        if (s[i] instanceof int[]) t[i]= clone((int[])s[i]);
        else {
          if (s[i] instanceof boolean[]) t[i]= clone((boolean[])s[i]);
          else {
            if (s[i] instanceof float[]) t[i]= clone((float[])s[i]);
            else {
              if (s[i] instanceof Object) t[i]= s[i];
            }
          }
        }
      } 
    }
    return t;
  } 
} 
