/** Depot4 (c) J. Lampe 1996-2010
 List.java

 * @author  Juergen Lampe
 * @version  1.9.4
 * $Date: 2010/05/11 $
 */

package Dp4;

import java.util.ArrayList;

public class List implements List_List{

	public int len= 0;
	private java.util.List lst= new ArrayList();

	//--------------------------------- Idx ------------------------
	public int Idx(String k){
		return lst.lastIndexOf(k)+1;
	} 
	//--------------------------------- Extend ---------------------
	public void Extend(String k){
		lst.add(k); 
		len= lst.size();
	} 
	//--------------------------------- Unite ----------------------
	public void Unite(String k){
		if (lst.indexOf(k)==-1) {
			lst.add(k); 
			len= lst.size();
		}
	} 
	//--------------------------------- Item -----------------------
	public tNode Item(int i){
		if (i>len) {
			return null;
		}
		return Chars.appStr(null, (String)lst.get(i-1));
	} 
	//--------------------------------- len ------------------------
	public int len(){
		return len;
	} 
	//--------------------------------- Cut ------------------------
	public void Cut(int last){
		for (int i= lst.size()-1; i>=last; i--) {
			lst.remove(i);
		}
		len= lst.size();
	} 
	//-------------------------------- Exchng ----------------------
	public void Exchng(int j, int k){
		Object h= lst.get(j-1);
		lst.set(j-1, lst.get(k-1));
		lst.set(k-1, h);
	} 
	//--------------------------------- Sort ----------------------
	public void Sort(int from, int toIdx){
		int count= java.lang.Math.min(len, toIdx);
		for (int i= from; i<=count-1; i++) {
			for (int j= i+1; j<=count; j++) {
				if (((String)lst.get(i-1)).compareTo((String)lst.get(j-1))>0)
					Exchng(i, j);
			}
		}
	} 


	public static int Idx(List_List l, String k) {
		return l.Idx(k);
	}

	public static void Extend(List_List l, String k) {
		l.Extend(k);
	}

	public static void Unite(List_List l, String k) {
		l.Unite(k);
	}

	public static tNode Item(List_List l, int k) {
		return l.Item(k);
	}

	public static int len(List_List l) {
		return l.len();
	}

	public static void Cut(List_List l, int k) {
		l.Cut(k);
	}

	public static void Exchng(List_List l, int k, int j) {
		l.Exchng(k, j);
	}

	public static void Sort(List_List l, int k, int j) {
		l.Sort(k, j);
	}

	public static List New() {
		return new List();
	}
}
