/** Depot4 (c) J. Lampe 1996-2010

 	Source reader state description


    * @author  Juergen Lampe
    * @version  1.9.4
    * $Date: 2010/05/07 $
    */

package Dp4;


public class Prs0 {

	/** Analysis state */
	public boolean A= true;

	/**  */
	public InSt inp;

	/** Current source object */
	public Source currentSource= null;

	/** Skip state, sk>0 means skipping */
	protected int sk= 0;

	/** accept state of ac and nc */
	protected boolean ab= true, nb;

	/** current character, next character */
	protected char ac, nc;

	/** Constructor */
	public Prs0(){}

	public SourcePos GetPos() {
		return currentSource.GetPos();
	}

	public String getPositionString() {
		return currentSource.getPositionString();
	}

	public void LogPos() {
		currentSource.LogPos();
	}

	public void SetPos(SourcePos t) {
		currentSource.SetPos(t);
	}
	
	
}
