/** Depot4 (c) J. Lampe 1996-2010
    PrsC.java
    
    extends Prs: makes capitalisation of literal terminals insignificant
    
    @author  Juergen Lampe
    @version  1.9.4
    Date:   24.04.2003
    */
    
package Dp4;


public class PrsC extends Prs{

	public PrsC(Translator translator) {
		super(translator);
	}

// ------- compare string / ignore letter case ---------------------------------
  public void CS(String sp){ 
		int l, k= 0, i; 
		char c; 
		String s;
		
    Skip();
    s= sp.toUpperCase();
    l= s.length()-1;
		if (l>0 && s.charAt(0)==Base.abbrChr && Character.isDigit(s.charAt(1))) {
			k= 2;
			i= Integer.parseInt(s.substring(1,2))+2;
			for (;;) {
				if (k>l) { 
					c= Character.toUpperCase(AC());
					this.A= !Character.isLetterOrDigit(c); 
					break;
				}
				if (s.charAt(k)== Character.toUpperCase(AC())) { 
					k+= 1; 
					acc();
				} else {
					if (k<i) { 
						this.A= false; 
						break;
					} else { 
						c= Character.toUpperCase(AC());
						this.A= !Character.isLetterOrDigit(c); 
						break;
					}
				}
			}
		} else {
      for (;;) {
        if (k>l) break;
        if (s.charAt(k)== Character.toUpperCase(AC())) { 
					k+= 1; 
					acc();
				} else { 
					this.A= false; 
					break;
				}
      }
    }
  }
}
