/** Depot4 (c) J. Lampe 1996-2010
    StringStream.java

 * @author  Juergen Lampe
 * @version  1.9.4
 * Date:   05.03.2003
 */

package Dp4;

public class StringStream extends Streams implements InStream, OutStream{
	private String st;
	private int l, p=0;

	public void Set(int i){
		p= i;
	}
	public int Len(){ 
		return l;
	}
	public int Get(){ 
		return p;
	}
	public void Open() {
		p= 0;
	}
	public void Close() {}

	public char Read(){
		if (p<l) 
			return st.charAt(p++);
		else { 
			if (p==l) p++;               //6.6.97 problem with SRCTXT
			return '\00';
		}
	}

	public void WriteStr(String s) { 
		st= st+s; 
		l= st.length();
	}

	public StringStream(){
		st= ""; 
		l= st.length();
		sn= "IntStrBuf";
	}

	public StringStream(String s){
		st= ""; 
		l= st.length(); 
		sn= s;
	}
	

//	@Override
	public String Description() {
		return sn;
	}
	//------------------------- IString -----------------------------
	static public Source IString(String A) {
		return IString(A, "");
	}
	static public Source IString(String A, String name) {
		StringStream is= new StringStream(name);
		is.WriteStr(A);
		return StrmToken.StrmSrc(is);
	}
	public static StringStream OldB(String A){
		StringStream is= new StringStream("");
		is.WriteStr(A);
		return is;
	}
	public static StringStream POldB(String A, int b, int e){
		StringStream is= new StringStream("");
		if (e==-1||e>A.length()) e= A.length();
		is.WriteStr(A.substring(b, e+1));
		return is;
	}

	static {new StrmToken();} //load problems in Netscape
}
