/** Depot4 (c) J. Lampe 1996-2003
    appStrT.java
    
		Interface for target generating objects.
		Extendibility to new target types is based on this. Actual implementations
		may generate arbitrary objects regarding the String parameter as
		construction description.
		
	* @author	Juergen Lampe
	* @version 1.9.2
	* Date:		24.04.2003
  */
    
package Dp4;

public interface appStrT{

	/** Appends an object to the target
	* @param t the current target or null
	* @param a the String identifying the object to append
	*  (default implementation will append just this String)
	* @return the value of parameter t if it was not null, a newly generated
	*		tNode object otherwise 
	*/
  public tNode app(Dp4.tNode t, String a);
	
}
