/** Depot4 (c) J. Lampe 1996-2003

	* @author	Juergen Lampe
	* @version 1.9.2
	* Date:		24.04.2003
	*/

package Dp4;

/** Implements id and ident such as in original Pascal defined, i.e. only the first
 * eight characters are relevant, all characters are seen as uppercase.
*/

public final class identPascal extends identX {

  /**Constructor */
  identPascal(int i){
    super(i);
    conversion= ALLTOUPPERCASE;
    validChars= 8;
  }

  public identPascal(){}

	protected identX getNew(int i) {
		return new identPascal(i);
	}


	/** Returns true if c is a valid tail (all but the first) character
	*/
	protected boolean isFollowCharacter(char c) {
		return Character.isLetterOrDigit(c);
	}
}
