/** Depot4 (c) J. Lampe 1996-2010
 *
 *  root node type of a chain
 *  
	* @author	Juergen Lampe
	* @version  1.9.4
	* $Date: 2010/05/07 $
  */

package Dp4;

public class ptNode extends tNode {

	protected final tNode tNd;
	
	public ptNode(tNode a){
		tNd= a;
	}

	/** Return the sub chain's root node
	 * @return the tNd
	 */
	public tNode getTNd() {
		return tNd;
	}
	
	/* go into the chain
	 * @see Dp4.tNode#invokeHandler(Dp4.Target)
	 */
	public void invokeHandler(Target m) {
		alltNodes(tNd, m);
	}
	
}
