/** Depot4 (c) J. Lampe 1996-2003
    Trace.java
		
		An extension of NTprocMonT that traces the call sequence onto a protocol.
		
		Does not belong to the core classes
    
    @author  J. Lampe
    @version 1.8
    Date:   4.3.98
    */
    
package Dp4x;

import Dp4.*;

public class Trace extends NTprocMonT{
  int traceCount= 0;
  static Trace tp= new Trace();
	
  public trgts parse(NonTermT t, Prs p) {
    trgts h; 
		int c;
    c= traceCount++;
    OP.WrStr("-- call   "+c+" "+t.name+"\n");
    h= super.parse(t, p);
    OP.WrStr("-- return "+c+" "+t.name);
    if (!p.A) 
			Dp4.OP.WrStr(" -failed");
    OP.WrLn();
    return h;
  }
	
	public static void reset(){
		tp.clear();
	}
	
	public void clear(){
		traceCount= 0;
	}
	
	public Trace(){
	}
}
