/** Depot4 IDE (c) J. Lampe 1999-2010
		TextDisplay.java
		
		* @author	Juergen Lampe
		* @version 1.3.3
		* Date:		28.2.2001
		* @since JDK 1.2
		*/
		
package Dp4.ide;

import java.awt.Font;
import java.awt.event.ActionEvent;

public interface TextDisplay {

	public static final int COPY_ACTION= 0, PASTE_ACTION= 1, CUT_ACTION= 2;
	
	public void open();
	public void save();
	public void newFile();
	public void setTitle(String title);
	public void find();
	public void findAgain();
	public void gotoPosition();
	public void clear();
	public void unDo();
	public void setFont(Font f);
	public Font getFont();
	public boolean isOpenEnabled();
	public boolean isSaveEnabled();
	public boolean isChanged();
	public void setInactive();
	public void action(int type, ActionEvent ev);
}
