/** Depot4 (c) J. Lampe 1996-2003

	* @author	Juergen Lampe
	* @version 1.9.2
	* Date:		24.04.2003
*/
// lexer of Depot4's Ml4 to Java Translator 

package Ml4j;

public final class Ml4jLex extends  Dp4.NTprocedure {
  Ml4jLex(int i){
    this.m= i;
  }
	
	public Dp4.AccTab KWL;
	private Ml4jLex y_ntp_id, y_ntp_str, y_ntp_num, y_ntp_srcstr;
	private Dp4.Translator y_translator;
	private Dp4.NonTerm y_nt_id,	y_nt_str,	y_nt_num,	y_nt_srcstr;
	private char[] ac= new char[256];

//------------------------ id ------------------------
	private Dp4.trgts y_p_id(Dp4.NonTermT y_NT, Dp4.Prs y_Prs){
		Dp4.trgts y_0tg= new Dp4.trgts();
		char C;
		int i= 0;
    Dp4.NonTermT y_yNT= y_translator.curNT; 
		y_translator.curNT= y_NT;
		y_Prs.Skip();
		C= y_Prs.AC();
		y_Prs.A= Character.isLetter(C);
		if (y_Prs.A) {
		  y_Prs.acc(); ac[i++]= C;
		  while ( Character.isLetterOrDigit(C= y_Prs.AC())) {
		    y_Prs.acc(); ac[i++]= C;
		  }
		}
		if (y_Prs.A) { 
			y_0tg.trg0= String.copyValueOf(ac, 0, i);
			if (KWL.Check(y_0tg.trg0)) { 
				y_Prs.A= false; 
				return y_0tg;
			}
			//------------------------- traget no 1 ------------------------
			y_0tg.trg1= Dp4.Chars.appStr(null, y_0tg.trg0);
		}
    y_translator.curNT= y_yNT;
    return y_0tg;
	}

	//------------------------ str ------------------------
	private Dp4.trgts y_p_str(Dp4.NonTermT y_NT, Dp4.Prs y_Prs){
		Dp4.trgts y_0tg= new Dp4.trgts();
		Dp4.NonTermT y_yNT;
		char C;
		int i= 0;
		y_yNT= y_translator.curNT; y_translator.curNT= y_NT;
		y_Prs.Skip();
		C= y_Prs.AC();
		y_Prs.A= C=='"'||C=='\'';
		if (y_Prs.A) {
		  y_Prs.acc();
		  for (;;) {
		    ac[i++]= y_Prs.AC(); y_Prs.acc();
		    if (ac[i-1]==C) {
		      if (y_Prs.AC()==C) 
						y_Prs.acc();
		      else {
						i--; 
						break;
		      }
		    }
		    if (ac[i-1]=='"') {
					ac[i-1]='\\'; 
					ac[i++]='"';
		    }
		  }
		}
		if (y_Prs.A) {
		  y_0tg.trg0= String.copyValueOf(ac, 0, i);
			//------------------------- traget no 1 ------------------------
		  y_0tg.trg1= Dp4.Chars.appStr(null, y_0tg.trg0);
		}
		y_translator.curNT= y_yNT;
		return y_0tg;
	}

	//------------------------ num ------------------------
	private Dp4.trgts y_p_num(Dp4.NonTermT y_NT, Dp4.Prs y_Prs){
	  Dp4.trgts y_0tg= new Dp4.trgts();
		char C;
		int i= 0;
		Dp4.NonTermT y_yNT= y_translator.curNT; y_translator.curNT= y_NT;
		y_Prs.Skip();
		C= y_Prs.AC();
		y_Prs.A= Character.isDigit(C);
		if (y_Prs.A) {
		  y_Prs.acc(); 
			ac[i++]= C;
		  while ( Character.isDigit(C = y_Prs.AC())) {
		    y_Prs.acc(); 
				ac[i++]= C;
		  }
		}
		if (y_Prs.A) {
		  y_0tg.trg0= String.copyValueOf(ac, 0, i);
			//------------------------- traget no 1 ------------------------
		  y_0tg.trg1= Dp4.Chars.appStr(null, y_0tg.trg0);
	  }
		y_translator.curNT= y_yNT;
	  return y_0tg;
	}

	//------------------------ srcstr ------------------------
	private Dp4.trgts y_p_srcstr(Dp4.NonTermT y_NT, Dp4.Prs y_Prs){
		char C;
		int i= 0;
		Dp4.trgts y_0tg= new Dp4.trgts();
		Dp4.NonTermT y_yNT;
		y_yNT= y_translator.curNT; y_translator.curNT= y_NT;
		y_Prs.Skip();
		C= y_Prs.AC();
		y_Prs.A= C=='"'||C=='\'';
		if (y_Prs.A) {
		  y_Prs.acc();
		  for (;;) {
		    ac[i++]= y_Prs.AC(); 
				y_Prs.acc();
		    if (ac[i-1]==C) {
		      if (y_Prs.AC()==C) y_Prs.acc();
		      else {i--; break;}
		    }
		    if (ac[i-1]=='"') {
					ac[i-1]='\\'; 
					ac[i++]='"';
		    }
		  }
		}
		if (y_Prs.A) {
		  y_0tg.trg0= String.copyValueOf(ac, 0, i);
			//------------------------- traget no 1 ------------------------
		  y_0tg.trg1= Dp4.Chars.appStr(null, y_0tg.trg0);
		}
		y_translator.curNT= y_yNT;
		return y_0tg;
	}

	public void init(Dp4.Translator translator){
		translator.modNT("id","Ml4jLex");
		translator.modNT("str","Ml4jLex");
		translator.modNT("num","Ml4jLex");
		translator.modNT("srcstr","Ml4jLex");
		Ml4jLex[] y_ntp_= new Ml4jLex[4];
		for (int i= 0;i<y_ntp_.length; i++)
		  y_ntp_[i]= new Ml4jLex(i);
		translator.installNT("id", y_ntp_[0]);
		translator.installNT("str", y_ntp_[1]);
		translator.installNT("num", y_ntp_[2]);
		translator.installNT("srcstr", y_ntp_[3]);
		Dp4.AccTab KWL= Dp4.AccTab.Init();
		KWL.addString("INIT");
		KWL.addString("END");
		for (int i= 0;i<y_ntp_.length; i++){
		  y_ntp_[i].y_translator= translator;
		  y_ntp_[i].y_nt_id= translator.registNT("id");
		  y_ntp_[i].y_nt_str= translator.registNT("str");
		  y_ntp_[i].y_nt_num= translator.registNT("num");
		  y_ntp_[i].y_nt_srcstr= translator.registNT("srcstr");
		  y_ntp_[i].y_ntp_id= y_ntp_[0];
		  y_ntp_[i].y_ntp_str= y_ntp_[1];
		  y_ntp_[i].y_ntp_num= y_ntp_[2];
		  y_ntp_[i].y_ntp_srcstr= y_ntp_[3];
			y_ntp_[i].KWL= KWL;
		}
	}

	private final int m;
	
	public Dp4.trgts parse(Dp4.NonTermT NT, Dp4.Prs Prs){
	  switch(this.m) {
	    case 0: return y_p_id(NT, Prs);
	    case 1: return y_p_str(NT, Prs);
	    case 2: return y_p_num(NT, Prs);
	    case 3: return y_p_srcstr(NT, Prs);
	  }
	 return new Dp4.trgts(); // this is an error
	}

  public Ml4jLex(){
	  m= -1; // create dummy instance
	}
}