(*  ****** ! ******** for use with Depot4/Java only ****** ! ******** *)
MODULE Ml4jModule                  
  IMPORTS Dp4List, Dp4OP, Dp4Util, Dp4Map;
TYPE HVarsT = RECORD ci,cx,ti,tx: INT END;
      VarsT  = FLEX OF RECORD tp, x: INT END;
TYPEND;
Ml4jModule =

GLOBVAR DCL ntL, nt1L, ntxL, impL, ntmL, gvL, TypL, VarL: Dp4List.List;
  DCL init, typnr, ct, srctxt, UsN, UsO, Usc, ext, globd, stat  : INT;
  DCL Dp4Date, RuleId, packg                      : SYM;
  DCL HVars : HVarsT;
  DCL gvT, impLn  : FLEX OF TXT;
  DCL Tpdsc: FLEX OF RECORD tpx, init: INT; dsc, t1, t2: TXT END;
  DCL Types: FLEX OF RECORD kd, idx: INT END;
  DCL Vars : VarsT;
  USE ModuleIdent: SYM;   USE check: INT;
VAR oi, ot, ov, om, NR, vl, ini: INT;   mid, Rids0: SYM;  Rids: FLEX OF SYM;
LOCAL 'id'<- 'Ml4jLex','str'<-'Ml4jLex', 'num'<-'Ml4jLex', 'srcstr'<-'Ml4jLex';
 Dp4Date:= Dp4Util.Date();
 Dp4List.New(impL);  Dp4List.New(TypL); Dp4List.New(ntmL);
 Dp4List.New(gvL); Dp4List.New(VarL);
 Dp4List.Extend(impL,'yyPrs'); impLn[Dp4List.len(impL)]:= 'y_Prs';
 Dp4List.Extend(impL,'yB');impLn[Dp4List.len(impL)]:= 'Dp4.Base';
  typnr:= 10; ct:= 0;  NR:= 0;  stat:= 1; check:= 0; packg:= '';
  DefCom('$2*:Dp4jDir$(*!','*) ');  Skip();
       [/om/ 'MODULE' $ !! id mid:= id_0
                     Dp4OP.WrStr('Module ');Dp4OP.WrStr(mid);Dp4OP.WrLn()]
       [/oi/ '$6IMPORTS' !! Ml4jImports ]
       [/ot/ 'TYPE' !! Ml4jTypeDecl '$3TYPEND' !!  [//';']   ]
       [/ov/ 'VAR' $ !! Ml4jVars ]
  vl:= Dp4List.len(VarL); stat:= 0;
  Ml4jRule (/1+om/ mid:= RuleId;|) Rids0:= RuleId;
    ModuleIdent:= mid;
  [/(om)/{/..NR/ Dp4List.Cut(VarL, vl)
                Rules:Ml4jRule[i]; Rids[i]:= RuleId }]
  [/ini/'INIT'$ stat:= 1; Inits: Ml4jSrcExp ]
  [/(om)/ [// 'END'$ !! id (//!id_0=mid| ERROR(20)) ] ]
  (//!Len(packg)>0; (//!packg='#'; packg:= '';|);|  packg:= Dp4Util.getPrefix(mid);)
-> (*-------------------------------------------------------------------*)
'// generated with Depot4''s Ml4 to Java Translator 1.9.4 of ' Ml4Date ' (c)J.Lampe \n'
'//  'Dp4Date' \n\n' (!Len(packg)>0;'package ' packg ';\n\n')
'public final class ' mid ' extends  Dp4.NTprocedure {\n  protected ' mid '(int i){\n    this.m= i;\n  }\n\n'
<'I +'>
  [/ot/  Ml4jTypeDecl_ ]
  (* types *)
  Ml4jRule_2 {/..NR/ Rules_2[i]}
  (* variables *)
  [/ov/ Ml4jVars_ ] Ml4jRule_4 {/..NR/ Rules_4[i]}
  [/Dp4List.len(gvL)/ 'private Dp4.Glob '
      {/..Dp4List.len(gvL)/ 'y_10' Dp4List.Item(gvL,i) (!i<Dp4List.len(gvL); ',\n        ')} ';\n']
<'I 1'>
 'private ' mid ' y_ntp_' Rids0 
 {/..NR/',' (!i MOD 6=0;' \n   ')' y_ntp_' Rids[i] } ';\n'
 'private Dp4.Translator y_translator;\n'
 [/Dp4List.len(gvL)/'private Dp4.Glob y_glob;\n']
 [/Dp4List.len(ntmL)/ 'private Dp4.NonTerm y_nt_' Dp4List.Item(ntmL,1); <'I +3'>
      {/=2..Dp4List.len(ntmL)/ ',\ny_nt_' Dp4List.Item(ntmL,i)} <'I -3'> ';\n']
  (* procedures *)
  [/ov/ Ml4jVars_2]
  Ml4jRule_  {/..NR/ Rules_[i]}
<'I 1'>
 'public void init(Dp4.Translator translator){\n' <'I +'>
 Ml4jRule_3 {/..NR/Rules_3[i]}
   (!Rids0# mid 'translator.modNT("' Rids0 '","' mid '");\n' )
  {/..NR/ 'translator.modNT("' Rids[i] '","' mid '");\n' }
  
  mid '[] y_ntp_= new ' mid '['(NR+1) '];\n'
  'for (int i= 0;i<y_ntp_.length; i++)\n  y_ntp_[i]= new ' mid '(i);\n'
  '\ntranslator.installNT("' Rids0 '", y_ntp_[0]);\n'
  {/..NR/ 'translator.installNT("' Rids[i] '", y_ntp_[' i ']);\n' }
  'for (int i= 0;i<y_ntp_.length; i++){\n'
  '  y_ntp_[i].y_translator= translator;\n'
  [/Dp4List.len(gvL)/'  y_ntp_[i].y_init_globals(translator);\n']
  {/..Dp4List.len(ntmL)/ '  y_ntp_[i].y_nt_' Dp4List.Item(ntmL,i)'= translator.registNT("'
       Dp4List.Item(ntmL,i) '");\n' }
  '  y_ntp_[i].y_ntp_' Rids0 '= y_ntp_[0];\n'
  {/..NR/'  y_ntp_[i].y_ntp_' Rids[i] '= y_ntp_[' i '];\n'} 
  '}\n'

 [/ini/Inits_ ';\n']
 <'I -'>
 '\n}\n'
  [/Dp4List.len(gvL)/ 'private void y_init_globals(Dp4.Translator translator){\n  y_glob= translator.getGlob();\n'
      {/..Dp4List.len(gvL)/ '  y_10' Dp4List.Item(gvL,i) '= y_glob.Mark("'
      Dp4List.Item(gvL,i)'","' gvT[i] '");\n'} '}\n']

  '\nprivate final int m;\npublic Dp4.trgts parse(Dp4.NonTermT NT, Dp4.Prs Prs){\n'
  (!NR=0; '  return y_p_' Rids0 '(NT, Prs);\n}\n'
  | '  switch(this.m) {\n    case 0: return y_p_' Rids0 '(NT, Prs);\n'
	{/..NR/'    case ' i ': return y_p_'Rids[i]'(NT, Prs);\n' }
	'    default: return new Dp4.trgts(); // this is an error\n  }\n}\n' )
  '\n\npublic ' mid '(){\n  m= -1; // create dummy instance\n}' <'I -'> '\n}\n'
.
(*-----------------------------------------------------------------------------*)
Ml4jLocals =
  { (!i=1|',') s: Ml4jStrVar[i]  '<-' t: Ml4jStrVar[i]  }
->
  { 'y_translator.pushNT(' s_[i] ', ' t_[i] ');\n' }
->
  { 'y_translator.popNT(' s_[i] ');\n' }
.
Ml4jStrVar =    (str| Ml4jVarUse)
-> ( '"' str_ '"' | Ml4jVarUse_).

Ml4jQualId=
GLOBVAR USE ct: INT; USE impL:Dp4List.List; USE impLn: FLEX OF TXT;
   id '.' i:= Dp4List.Idx(impL,id_0); !(i#0)
   id
   ct:= 0
->
   impLn[i]'.' id_0
->
   impLn[i]
->
   id_0.

Ml4jImports=
GLOBVAR USE impL:Dp4List.List; USE impLn: FLEX OF TXT;
VAR idx : INT;
        {(//!i#1;','|) id Dp4List.Extend(impL, id_0); idx:= Dp4List.len(impL);
            (// ':=' str; impLn[idx]:= str_ | impLn[idx]:= Dp4Map.getMap(id_0);) } ';'
.
Dp4jDir =
GLOBVAR USE check: INT; USE packg: SYM;
VAR s: SYM;
{//(//'package' '=' id; s:= id_0; {//'.' id; s:= s+'.'+id_0}; packg:= s;
          |'nopackage'; packg:= '#';
          |'check'; check:= 1;
          |'nocheck'; check:= 0;)}.

END Ml4jModule
