/** Depot4 (c) J. Lampe 1996-2003
    CharacterTarget.java
		
		An interface for tNode objects which implement target types that
		can contain Strings and can be converted into Strings and where
		'number of characters' makes sense.
    
	* @author	Juergen Lampe
	* @version 1.9.2
	* Date:		24.04.2003
    */
    
package Dp4;

public interface CharacterTarget{

	public String getString();
	
	public int getNoOfCharacters();
	
	public void appendStr(String string);
	
}
