/** Depot4 (c) J. Lampe 1996-2003
    ChrtNode.java
		
		Target node type for simple Strings.
 		@see tNode
 		@see CharacterTarget

	* @author	Juergen Lampe
	* @version 1.9.2
	* Date:		24.04.2003
	*/

package Dp4;

public class ChrtNode extends tNode implements CharacterTarget{

  protected final StringBuffer str;
  
	/** Constructor (for subclassing only) */
  protected ChrtNode () { 
		str= new StringBuffer(); 
	}
	
  public ChrtNode (String a) { 
		str= new StringBuffer(a); 
	}
	
	public String getString() {
		return str.toString();
	}
	
	public int getNoOfCharacters() {
		return str.length();
	}
	
	public void appendStr(String string) {
		str.append(string);
	}
	
}
