/** Depot4 (c) J. Lampe 1996-2010
Glob.java

    @author  Juergen Lampe
    @version  1.9.4
    Date: 24.04.2003
    */

package Dp4;

import java.util.Stack;

public class Glob  {

  private int kd= 0;
  private String Ide;
  private String Tdsc;
  private Object [] adr;
  private Object adro;
  private int [] adri;
  private float [] adrf;
  private boolean [] adrb;
  private Stack stck= new Stack();
  private Glob nxt= null;
	
	public static Glob getNewGroup() {
		Glob result= new Glob();
		result.Ide= "";
		result.Tdsc= "";
		return result;
	}
	
	//--------------------------------- Mark ----------------------------------
	public Glob Mark(String id, String tp){
		return mark(this, id, tp);
	}
    public static Glob mark(Glob gTab, String id, String tp){
        Glob r= null, h= gTab;
        while (h!=null) {
            if (h.Ide.equals(id) && h.Tdsc.equals(tp)) {
                return h;
            }
            h= h.nxt;
        }
        r= new Glob ();
        r.Ide= id;
        r.Tdsc= tp;
        r.nxt= gTab.nxt;
        gTab.nxt= r;
        return r;
    }
	public Object [] getOld(){
		  Object[] h= adr;
		  if (h==null) { 
		    OP.WrStr(" \""+Ide+"\" - "); 
				OP.ERROR(1012);
		  }
		  return h;
		} 
		public Object getOldo(){
		  Object h= adro;
		  if (h==null) { 
		    OP.WrStr(" \""+Ide+"\" - "); 
		    OP.ERROR(1012);
		  }
		  return h;
		} 
		public int [] getOldi(){
		  int[] h= adri;
		  if (h==null) { 
				OP.WrStr(" \""+Ide+"\" - "); 
				OP.ERROR(1012);
		  }
		  return h;
		} 
		public float [] getOldf(){
		  float[] h= adrf;
		  if (h==null) { 
				OP.WrStr(" \""+Ide+"\" - "); 
				OP.ERROR(1012);
		  }
		  return h;
		} 
		public boolean [] getOldb(){
		  boolean[] h= adrb;
		  if (h==null) { 
				OP.WrStr(" \""+Ide+"\" - "); 
				OP.ERROR(1012);
		  }
		  return h;
		}
	//--------------------------------- Old ----------------------------------
	public static Object [] getOld(Glob g){
	  Object[] h= g.adr;
	  if (h==null) { 
	    OP.WrStr(" \""+g.Ide+"\" - "); 
			OP.ERROR(1012);
	  }
	  return h;
	} 
	public static Object getOldo(Glob g){
	  Object h= g.adro;
	  if (h==null) { 
	    OP.WrStr(" \""+g.Ide+"\" - "); 
	    OP.ERROR(1012);
	  }
	  return h;
	} 
	public static int [] getOldi(Glob g){
	  int[] h= g.adri;
	  if (h==null) { 
			OP.WrStr(" \""+g.Ide+"\" - "); 
			OP.ERROR(1012);
	  }
	  return h;
	} 
	public static float [] getOldf(Glob g){
	  float[] h= g.adrf;
	  if (h==null) { 
			OP.WrStr(" \""+g.Ide+"\" - "); 
			OP.ERROR(1012);
	  }
	  return h;
	} 
	public static boolean [] getOldb(Glob g){
	  boolean[] h= g.adrb;
	  if (h==null) { 
			OP.WrStr(" \""+g.Ide+"\" - "); 
			OP.ERROR(1012);
	  }
	  return h;
	}
	
	public static Object [] Old(Glob g){
		return getOld(g);
	}
	public static Object Oldo(Glob g){
		return getOldo(g);
	}
	public static int [] Oldi(Glob g){
		return getOldi(g);
	}
	public static float [] Oldf(Glob g){
		return getOldf(g);
	}
	public static boolean [] Oldb(Glob g){
		return getOldb(g);
	}
	

//--------------------------------- New ----------------------------------
	public static void New(Object[] o, Glob g){
	  g.stck.push(g.adr);
	  g.adr= o;
	} 
	public static void New(Object o, Glob g){
	  g.kd= 4;
	  g.stck.push(g.adr);
	  g.adro= o;
	} 
	public static void New(float[] o, Glob g){
	  g.kd= 3;
	  g.stck.push(g.adrf);
	  g.adrf= o;
	} 
	public static void New(boolean[] o, Glob g){
	  g.kd= 2;
	  g.stck.push(g.adrb);
	  g.adrb= o;
	} 
	public static void New(int[] o, Glob g){
	  g.kd= 1;
	  g.stck.push(g.adri);
	  g.adri= o;
	}
	public void createNew(Object o, Glob g){
	  g.kd= 4;
	  g.stck.push(g.adr);
	  g.adro= o;
	} 
	
	public void free() {
		  switch (kd){
		  case 1: adri= (int[])stck.pop();
				break;
		  case 2: adrb= (boolean[])stck.pop();
				break;
		  case 3: adrf= (float[])stck.pop();
				break;
		  case 4: adro= stck.pop();
				break;
		  default: adr= (Object[])stck.pop();
		}		
	}
	 
	//--------------------------------- Free ----------------------------------
	public static void Free(Glob g){
		g.free();
	}
	public static void free(Glob g){
		g.free();
	} 
	//--------------------------------- ClrGlobals ----------------------------------
	public void ClrGlobals(){
		clrGlobals(this);
	}
	public static void clrGlobals(Glob gTab){
	  Glob h= gTab;
	  while (h!=null) {
	    while (!h.stck.empty()) {
				free(h);
	    }
	    h= h.nxt;
	  }
	} 

} 
