/** Depot4 (c) J. Lampe 1996-2010
    InStream.java
    
	* @author	Juergen Lampe
	* @version  1.9.4
	* Date:		24.04.2003
  */
    
package Dp4;

public interface InStream {

	/** Sets the read position such that
	 * int p= Get(); Read(); Set(p);
	 * should end up in the same state as before.
	 */
	public abstract void Set(int p);

	public abstract int Len();

	/** Returns the read position */
	public abstract int Get();

	public void Open();

	public void Close();

	public char Read();
	
	String Description();
}
