/** Depot4 (c) J. Lampe 1996-2010
    StrBuf.java
    
    * @author  Juergen Lampe
    * @version  1.9.4
    * date:   24.04.2003
    */
    
package Dp4;

import java.util.Hashtable;

public class StrBuf extends Streams implements OutStream, InStream{
	
     protected StringBuffer st;
     private int p= 0;
     private static Hashtable bufs= new Hashtable();

     public static StrBuf New() {
    	 return new StrBuf();
     } 
     
     public static StrBuf New(String s) {
    	 return new StrBuf(s);
     }
     
     public static StrBuf Old(String s) {
    	 Object obj = bufs.get(s);
    	 if (obj instanceof StrBuf) {
    		 return (StrBuf)obj;
    	 } else {
    		 return new StrBuf(s);
    	 }
     } 
     
     public static StrBuf POld(String s, int b, int e) {
    	 StrBuf h= (StrBuf)bufs.get(s);
    	 h.beg= b;
    	 h.end= e;
    	 return h;
     } 
  //------------------------- IFile -----------------------------
	public static Source IFile(String A) {
		return StrmToken.StrmSrc(Old(A));
	}
	
	public static void Dump(Streams s){
		if (s instanceof StrBuf)
			Dp4.OP.WrStr("-- StrBuf Dump '"+ s.sn+"' --\n"
					+ ((StrBuf)s).st.toString() +"\n");
	}
	
	public StrBuf(String t) {
		sn= t;
		st= new StringBuffer(512);
		bufs.put(sn, this);
	}
	
	public StrBuf() {
		this("StringBuffer");
	}

	// -- OutStream
	//public void Write(char c) { st.append(c);}
	public void WriteStr(String s) {
		st.append(s);
	}

// -- InStream
  public void Set(int i){
	  p= i;
  }
  
  public int Len(){
	  int sl= st.length();
	  if (end>-1 && sl>end) {
		  sl= end+1; 
	  }
	  return sl-beg;
  }
  
  public int Get(){
	  return p;
  }
  
  public void Open() {
	  p= beg;
  }
  
  public char Read(){
	  if (end>-1 && p>=end)
		  return '\00';
	  if (p<st.length())
		  return st.charAt(p++);
	  else {
		  if (p==st.length()) p++;               //6.6.97 problem with SRCTXT
		  return '\00';
	  }
  }

    
      /* (non-Javadoc)
       * @see Dp4.InStream#Description()
       */
//      @Override
      public String Description() {
     	  return "Internal";
      }
    
      public String toString() {
    	  return st.toString();
      }
}
