/** Depot4 (c) J. Lampe 1996-2010
    XtNode.java
		
		The class of special 'extension' nodes.
		The extension is described as String hold in field xdsc.
    
    @author  J. Lampe
    @version  1.9.4
    $Date: 2010/05/07 $
    */
    
package Dp4;

public class XtNode extends tNode{

	private final tNode pre;
	private String xdsc= "";

	XtNode(tNode t){ 
		pre= t; 
	}

	/**
	 * @return the xdsc
	 */
	public String getXdsc() {
		return xdsc;
	}

	/**
	 * @param xdsc the xdsc to set
	 */
	public void setXdsc(String xdsc) {
		this.xdsc= xdsc;
	}

	/**
	 * @return the pre
	 */
	public tNode getPre() {
		return pre;
	}
	
}
