/** Depot4 (c) J. Lampe 1996-2003

	* @author	Juergen Lampe
	* @version 1.9.2
	* Date:		24.04.2003
	*/

package Dp4;

/** Implements id and ident such that exactly Java identifiers are accepted.
*/

public final class identJava extends identX {
	
  /**Constructor */
  identJava(int i){
    super(i);
  }

  public identJava(){}
	
	protected identX getNew(int i) {
		return new identJava(i);
	}
	
	/** Returns true if c is a valid start (first) character
	*/
	protected boolean isStartCharacter(char c) {
		return Character.isJavaIdentifierStart(c);
	}
	
	/** Returns true if c is a valid tail (all but the first) character
	*/
	protected boolean isFollowCharacter(char c) {
		return Character.isJavaIdentifierPart(c);
	}
}
