/** Depot4 (c) J. Lampe 1996-2010
  *
  * lexem: single quoted string
  * Accepts a string which may contain the quoting character escaped by preceding backslash.
  *
	* @author	Juergen Lampe
	* @version  1.9.4
	* Date:		13.06.2003
	*/
package Dp4;

public final class sqstresc extends  NTprocedure {

	private Translator y_translator;

	//------------------------ str ------------------------
	private trgts y_p_sqstringesc(NonTermT y_NT, Prs y_Prs){
		StringBuffer t0= new StringBuffer(),
		t2= new StringBuffer();
		trgts y_0tg= new trgts();
		NonTermT y_yNT;
		y_yNT= y_translator.curNT; y_translator.curNT= y_NT;
		y_Prs.Skip();
		final char C= y_Prs.AC();
		y_Prs.A= C=='\'';
		if (y_Prs.A) {
			t2.append(C);
			char ac;
			boolean wasEsc= false;
			for (; y_Prs.A;) {
				y_Prs.acc();
				ac= y_Prs.AC(); 
				if (ac==C) {
					if (wasEsc) {
						y_Prs.acc();
						t0.deleteCharAt(t0.length()-1);
					} else {
						t2.append(C);
						break;
					}
				}
				wasEsc= ac=='\\' && !wasEsc;
				y_Prs.A= ac!='\0';
				t0.append(ac);
				t2.append(ac);
			}
			if (y_Prs.A) {
				y_Prs.acc();
			}
		}
		if (y_Prs.A) {
			y_0tg.trg0= t0.toString();
			//------------------------- target no 1 ------------------------
			y_0tg.trg1= Chars.appStr(null, y_0tg.trg0);
			//------------------------- target no 2 ------------------------
			y_0tg.trg2= Chars.appStr(null, t2.toString());
		}
		y_translator.curNT= y_yNT;
		return y_0tg;
	}

	public void init(Translator translator){
		sqstresc y_ntp_= new sqstresc();
		translator.installNT("sqstringesc", y_ntp_);
		translator.installNT("sqstresc", y_ntp_);
		y_ntp_.y_translator= translator;
	}

	public trgts parse(NonTermT NT, Prs Prs){
		return y_p_sqstringesc(NT, Prs);
	}

	public sqstresc(){
	}
}
