/** Depot4 (c) J. Lampe 1996-2001
Count.java
    
    @author  J. Lampe
    @version 1.9
    date:   4.3.98
    */
    
package Dp4x;

import Dp4.*;

public class Count extends NTprocMonT{

  int CallLevel= 0, maxCallLevel= 0;
  int poi= 0;
  int maxntnr= 0, maxbst= 2048;
  int [] bst= new int[maxbst];
  CountList lst = new CountList(this);
  private boolean no= true;
	private Translator translator;
  
  int[] cnts= null; // dummy
	
//----------------------- parse -----------------------
  public trgts parse(NonTermT t, Prs p) {
    trgts h;
    if (no) { 
			Prs.addBrPtObs(p, new CountBP(this));
      no= false;
		}
    int c= ((NonTerm)t).id;
    if (c>maxntnr) maxntnr= c;
    CallLevel++;
    if (CallLevel>maxCallLevel) maxCallLevel= CallLevel;
    if (poi>=maxbst) {
      maxbst+= maxbst;
      bst= resize(maxbst, bst);
    }
    bst[poi++]= c;
    h= super.parse(t, p);
    CallLevel--;
    return h;
  }
//----------------------- List -------------------------
  public void List(){
    Dp4.OP.WrStr("Counts\n------\nmax. tree heigth:  "
    +maxCallLevel
    +"\nno. of nodes:  "
    +poi
    +"\n======================\n");
    cnts= new int [maxntnr+1];
    for (int i= 1; i<=maxntnr; i++) cnts[i]= 0;
    for (int j= 0; j<poi; j++) cnts[bst[j]]++;
    translator.enumerateNT(lst);
  }
	
  public static void reset(){}
	
	public void clear() {
  	CallLevel= 0;
		maxCallLevel= 0;
  	poi= 0;
  	maxntnr= 0;
		no= true;
	}
	
	
  public static int[] resize(int ns, int[] old){
    int [] nw= new int[ns];
    java.lang.System.arraycopy(old, 0, nw, 0, old.length);
    return nw;
  }
	
	public Count(Translator translator){
		this.translator= translator;
	}
}

/* ------------------------------------------------------- */
class CountList extends enumProcT{
  private Count count;
	
  public void process (Translator translator, NonTermT n){
    int c= ((NonTerm)n).id;
    if (c<=count.maxntnr) {
      c= count.cnts[c];
      if (c>0) 
				Dp4.OP.WrStr(((NonTerm)n).name+"\t"+c+"\n");
		}
  }
	
  CountList(Count c){ 
		count= c;
	}
}

/* ------------------------------------------------------- */
class CountBP extends BrPtObs {
  private Count count;
  private int p= -1, mst= 64; 
  private int[] st= new int [mst], cl= new int [mst];
  //----------------------------- ND ------------------------
  public void ND(Dp4.Prs0 P){
      super.ND(P); 
			p= -1;
  }
  //----------------------------- BT ------------------------
  public void BT(Dp4.Prs0 P){
      super.BT(P);
      if (p>=0) { 
				count.poi= st[p]; 
				count.maxCallLevel= cl[p];
			}
  }
  //----------------------------- DB ------------------------
  public void DB(Dp4.Prs0 P){
      super.DB(P); 
			if (p>-1) p--;
  }
  //----------------------------- SB ------------------------
  public void SB(Dp4.Prs0 P){
    super.SB(P);
    if (p>=mst-1) {
      mst+= mst;
      st= Count.resize(mst, st);
      cl= Count.resize(mst, cl);
    }
    st[++p]= count.poi; 
		cl[p]= count.maxCallLevel;
  }
	
  CountBP(Count c){ 
		count= c;
	}
}
