/** Depot4 (c) J. Lampe 1996-2001
    indOutStream.java
    
    @author  J. Lampe
    @version 1.8.2
    Date:   17.11.98
    */
    
package Dp4x;

import Dp4.OutStream;
import Dp4.SourcePos;
import Dp4.Streams;

public class indOutStream extends Streams implements OutStream{
    
    private static final String step= "  ";  // step width
    
    private OutStream S;
    private int ind= 0;
		private boolean isOnFirst= true;
    
    public indOutStream(OutStream O){
       S= O;
    }

    public void Open() { 
			S.Open();
			isOnFirst= true;
		}
    public void Close() { 
			S.Close();
		}
    public void WriteStr(String s) {
			if (isOnFirst) {
        for (int i= 0; i<ind; i++) S.WriteString(step);
				isOnFirst= false;
			}
			S.WriteString(s);
		}
    public void WriteLn(){
      S.WriteLn();
			isOnFirst= true;
    }
		
    public void set(int i, boolean isAbsolut) {
			if (isAbsolut)
				ind= i;
			else	
        ind+= i;
    }
  
    public void copy2Strm(SourcePos beg, SourcePos end) {
			S.copy2Strm(beg, end);
		}
}
